//
// FILE: CWorkerThreadHandler.h
//
// Copyright (c) 1997 by Aaron Michael Cohen and Mike Woodring
//
/////////////////////////////////////////////////////////////////////////

#ifndef __WorkerThread__
#define __WorkerThread__

#include <CMclGlobal.h>
#include <CMclEvent.h>
#include <CMclThread.h>

// CWorkerThreadHandler
//
// Defines our worker thread.  The fFault parameter to the
// constructor controls whether or not this thread will
// fault in order to demonstrate the MAD exception management
// technique.
//
class CWorkerThreadHandler : public CMclThreadHandler
{
    public:
        CWorkerThreadHandler( CMclEvent& ExitEvent, BOOL fFault );

        virtual unsigned ThreadHandlerProc( void );

    private:
        CMclEvent&  m_ExitEvent;
        BOOL        m_fFault;
};


#endif // __WorkerThread__
